/*
** Carousel2D v1.0 for jQuery
** Ítalo Alves Bezerra do Nascimento
** contact@italonascimento.com
*/

(function($) {
	$.fn.carousel2d = function (options) {
		var settings = $.extend({
			time			:300,
			wrapper			:'.wrapper',
			slider			:'.slider',
			items			:'.items',
			arrowPrev		:'.prev',
			arrowNext		:'.next',
			disabledOpacity	:0.5,
		}, options);
			
		var root 		= this;
			isAnimating = false;
			wrapper 	= this.find(settings.wrapper);
			slider 		= wrapper.find(settings.slider);
			prev 		= $(settings.arrowPrev);
			next 		= $(settings.arrowNext);
			items 		= slider.find(settings.items);
			single		= items.filter(':first');
			singleWidth = single.outerWidth(true);
			visible 	= Math.ceil(wrapper.innerWidth() / singleWidth);
			currentPage = 1;
			pages 		= Math.ceil(items.length / visible);
		
		// needed css config
		wrapper.css('overflow', 'hidden').css('position', 'relative');
		slider.css('width', (singleWidth * items.length)).css('left', '0').css('position', 'absolute');
		
		checkArrows();
		
		prev.click(function () {
			if(currentPage > 1){
				return root.goto(currentPage - 1);
			}
		});
		
		next.click(function () {
			if(currentPage < pages){
				return root.goto(currentPage + 1);
			}
		});
		
		root.goto = function(page) {
			if(page >= 1 && page <= pages){
				var dir = page < currentPage ? 1 : -1;
					n = Math.abs(currentPage - page);
					leftMove = singleWidth * dir * visible * n;
					
				currentPage = page;
				root.onStart(currentPage);
				
				checkArrows();
				
				slider.animate({
					left : '+=' + leftMove
				}, settings.time, function () {
					root.onComplete(currentPage);
				});
			}
		}
		
		root.onStart = function(page){}
		root.onComplete = function(page){}
		
		function checkArrows(){
			if(currentPage == 1){
				prev.css({opacity:settings.disabledOpacity, cursor:'default'});
			}else{
				prev.css({opacity:1, cursor:'pointer'});
			}
			if(currentPage == pages){
				next.css({opacity:settings.disabledOpacity, cursor:'default'});
			}else{
				next.css({opacity:1, cursor:'pointer'});
			}
		}
		
		root.reinitialize = function(){
			items 		= slider.find(settings.items);
			single		= items.filter(':first');
			singleWidth = single.outerWidth(true);
			visible 	= Math.ceil(wrapper.innerWidth() / singleWidth);
			currentPage = 1;
			pages 		= Math.ceil(items.length / visible);
			
			slider.css('left', '0')
			checkArrows();
		}
		
		return root;
	}; 
})(jQuery);